package jshow;

import java.awt.BorderLayout;
import java.awt.Cursor;
import java.awt.GridLayout;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.io.File;

import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTree;
import javax.swing.ScrollPaneConstants;
import javax.swing.tree.DefaultMutableTreeNode;
import javax.swing.tree.TreePath;

import jshow.thumb.ThumbPanel;
import jshow.util.Directory;

public class FileListPanel extends JPanel {

	private String startDir = null;

	private DefaultMutableTreeNode dmt = null;

	private JTree tree = null;

	private ThumbPanel thPanel = null;

	private JScrollPane scrollPane = null;

	private JPanel flPanel = null;

	class Enabler implements Runnable {
		public void run() {
			setCursor(Cursor.getPredefinedCursor(Cursor.DEFAULT_CURSOR));
			tree.setEnabled(true);
		}
	}

	class MouseListener extends MouseAdapter {
		public void mousePressed(MouseEvent e) {

			int selRow = tree.getRowForLocation(e.getX(), e.getY());
			TreePath selPath = tree.getPathForLocation(e.getX(), e.getY());
			if (selRow != -1) {
				if (e.getClickCount() == 1) {
					DefaultMutableTreeNode selDir = (DefaultMutableTreeNode) selPath
							.getLastPathComponent();
					Directory[] files = ((Directory) selDir.getUserObject())
							.listDirectories();
					DefaultMutableTreeNode child = null;

					selDir.removeAllChildren();

					for (int i = 0; i < files.length; i++) {
						child = new DefaultMutableTreeNode(files[i]);
						selDir.add(child);
						Directory[] childFiles = files[i].listDirectories();

						if (childFiles != null) {
							for (int j = 0; j < childFiles.length; j++) {
								child.add(new DefaultMutableTreeNode(
										childFiles[j]));
							}
						}
					}
				} else if (e.getClickCount() == 2) {
					
					setCursor(Cursor.getPredefinedCursor(Cursor.WAIT_CURSOR));
					tree.setEnabled(false);

					File[] files = ((Directory) ((DefaultMutableTreeNode) selPath
							.getLastPathComponent()).getUserObject())
							.listImageFiles();
					
					thPanel
							.setImageFiles(files);
					
					if (files.length == 0){
						setCursor(Cursor.getPredefinedCursor(Cursor.DEFAULT_CURSOR));
						tree.setEnabled(true);						
					}
				}
			}
		}
	}

	public FileListPanel(String startDir, ThumbPanel thPanel) {
		super(new BorderLayout());

		scrollPane = new JScrollPane(
				ScrollPaneConstants.VERTICAL_SCROLLBAR_AS_NEEDED,
				ScrollPaneConstants.HORIZONTAL_SCROLLBAR_NEVER);
		flPanel = new JPanel();

		this.thPanel = thPanel;
		this.startDir = startDir;
		makeDefaultTree();
		tree = new JTree(dmt);
		tree.addMouseListener(new MouseListener());
		flPanel.setLayout(new GridLayout(1, 1));
		flPanel.add(tree);
		scrollPane.setViewportView(flPanel);
		this.add(scrollPane);
		thPanel.setLastJob(new Enabler());
	}

	private void makeDefaultTree() {
		Directory root = new Directory(startDir);
		DefaultMutableTreeNode child = null;
		DefaultMutableTreeNode second = null;

		dmt = new DefaultMutableTreeNode(root);
		
		setCursor(Cursor.getPredefinedCursor(Cursor.WAIT_CURSOR));
		
		if (root.isDirectory()) {
			Directory[] rootFiles = root.listDirectories();

			for (int i = 0; i < rootFiles.length; i++) {
				Directory[] childFiles = rootFiles[i].listDirectories();
				child = new DefaultMutableTreeNode(rootFiles[i]);
				dmt.add(child);

				if (childFiles != null) {
					for (int j = 0; j < childFiles.length; j++) {
						second = new DefaultMutableTreeNode(childFiles[j]);
						child.add(second);
					}
				}
			}
		}
		setCursor(Cursor.getPredefinedCursor(Cursor.DEFAULT_CURSOR));
	}

	public Directory getCurrDir() {
		return (Directory) tree.getLastSelectedPathComponent();
	}
}
