package jshow.detail;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.Graphics;
import java.awt.image.BufferedImage;
import java.io.File;

import javax.imageio.ImageIO;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.ScrollPaneConstants;
import javax.swing.border.LineBorder;

public class EditImagePanel extends JPanel {
	private File file;

	private BufferedImage image;

	private JPanel imagePanel = null;

	private JPanel descPanel = null;

	private JPanel filteredPanel = null;

	private JScrollPane scrollPane = null;

	private final static int DESC_WIDTH = 300;

	private final static int DESC_HEIGHT = 100;

	class DescPanel extends JPanel {
		public DescPanel() {
			super();
			setLayout(new BorderLayout());
			setPreferredSize(new Dimension(DESC_WIDTH, DESC_HEIGHT));
			setBorder(new LineBorder(Color.BLACK));
			setBackground(Color.WHITE);
		}

		public void paintComponent(Graphics g) {
			g.drawString(" : " + file.getAbsolutePath(), 10, 15);
			g.drawString("ũ : " + file.length() + " bytes ", 10, 35);
			g.drawString("ػ : " + image.getWidth(null) + " X "
					+ image.getHeight(null), 10, 55);
		}
	}

	public EditImagePanel(File file) {
		super(new BorderLayout());
		this.file = file;
		try {
			image = ImageIO.read(file);
		} catch (Exception e) {
			e.printStackTrace();
		}

		imagePanel = new ImagePanel(image);
		descPanel = new DescPanel();
		filteredPanel = new FilteredImagePanel(imagePanel, image);

		scrollPane = new JScrollPane(
				ScrollPaneConstants.VERTICAL_SCROLLBAR_AS_NEEDED,
				ScrollPaneConstants.HORIZONTAL_SCROLLBAR_AS_NEEDED);

		add(filteredPanel, BorderLayout.NORTH);
		add(scrollPane, BorderLayout.CENTER);
		add(descPanel, BorderLayout.SOUTH);
		scrollPane.setViewportView(imagePanel);
	}
}
