package jshow.util;

import java.io.File;
import java.io.FileFilter;
import java.util.Vector;

public class Directory extends File {
	private static String GIF = "gif";

	private static String PNG = "png";

	private static String JPG = "jpg";

	private static int MAX_SIZE = 1024 * 1024;

	public Directory(String file) {
		super(file);
	}

	public String toString() {
		if (this.getParent() == null) {
			return this.getAbsolutePath();
		}
		return this.getName();
	}

	public Directory[] listDirectories() {
		File[] files = this.listFiles();

		if (files == null)
			return null;

		Vector<Directory> v = new Vector<Directory>();

		for (int i = 0; i < files.length; i++) {
			if (files[i].isDirectory()) {
				v.add(new Directory(files[i].getAbsolutePath()));
			}
		}

		return v.toArray(new Directory[0]);
	}

	public File[] listImageFiles() {
		return this.listFiles(new ImageFileFilter());
	}

	class ImageFileFilter implements FileFilter {
		public boolean accept(File file) {
			if (file.length() < MAX_SIZE
					&& !file.isDirectory()
					&& (file.getName().toLowerCase().endsWith(GIF)
							|| file.getName().toLowerCase().endsWith(JPG) || file
							.getName().toLowerCase().endsWith(PNG))) {
				return true;
			}

			return false;
		}
	}
}
