package jshow.util;

import java.awt.Graphics2D;
import java.awt.Image;
import java.awt.image.BufferedImage;

public class ImageUtil {

	// sun forum  

	public static BufferedImage toBufferedImage(Image image) {
		BufferedImage bufferedImage = new BufferedImage(image.getWidth(null),
				image.getHeight(null), BufferedImage.TYPE_INT_RGB);
		Graphics2D g2 = bufferedImage.createGraphics();
		g2.drawImage(image, 0, 0, null);
		g2.dispose();
		return bufferedImage;
	}

	public static BufferedImage getScaledImage(Image image, int width,
			int height) {
		double proHeight = (double) image.getHeight(null) / height;
		double proWidth = (double) image.getWidth(null) / width;
		Image retImage = null;

		if (image.getHeight(null) < height && image.getWidth(null) < width) {
			retImage = image;
		} else if (proHeight >= proWidth) {
			retImage = image.getScaledInstance((int) ((double) image
					.getWidth(null) / proHeight), height, Image.SCALE_FAST);
		} else {
			retImage = image.getScaledInstance(width, (int) ((double) image
					.getHeight(null) / proWidth), Image.SCALE_FAST);
		}

		return toBufferedImage(retImage);
	}
}
